﻿
----------------------------------------
-- Index
----------------------------------------
-- Variables
-- Getters
-- Frames
-- Background Frame
-- Small Frames
-- Functions
-- Options Frame
-- CheckButtons
-- Info Frame
-- Updates
-- Event Frames
-- Slash Commands
----------------------------------------


----------------------------------------
-- Variables
----------------------------------------

local FrameTable = {}
local firstRun = true
local initialTable = {}

----------------------------------------
-- Getters
----------------------------------------

function GetHKills()
   local HKills, _, _ = GetPVPLifetimeStats()
   return HKills
end

function GetHonor()
   local _, CurrInfo, _, _, _, _ = GetCurrencyInfo(392)
   return CurrInfo
end

function GetConquest()
   local _, CurrInfo, _, _, _, _ = GetCurrencyInfo(390)
   return CurrInfo
end

----------------------------------------
-- Frames
----------------------------------------

----------------------------------------
-- Background Frame
----------------------------------------

local BGStatFrame = CreateFrame("frame", "BGStatFrame")
BGStatFrame:SetBackdrop({
      bgFile = [[Interface\COMMON\ShadowOverlay-Right]],
      edgeFile = nill,
      tileSize = 16, edgeSize = 16,
      insets = { left = 3, right = 3, top = 5, bottom = 3 }
})
BGStatFrame:SetWidth(100)
BGStatFrame:SetHeight(300)
BGStatFrame:EnableMouse(true)
BGStatFrame:SetMovable(true)
BGStatFrame:SetPoint("Center", 200, 0)
BGStatFrame:RegisterForDrag("LeftButton")
BGStatFrame:SetScript("OnDragStart", BGStatFrame.StartMoving )
BGStatFrame:SetScript("OnDragStop", 
BGStatFrame.StopMovingOrSizing)
BGStatFrame:Show()

------------------------------------------------------------------------------------------------------------------------

local Icon = CreateFrame("Frame", "Icon", BGStatFrame)
Icon:SetWidth(22)
Icon:SetHeight(22)
function FactionIcon()
   local EnglishFaction, localizedFaction = UnitFactionGroup("player")
   if EnglishFaction == "Horde" then
      Icon:SetBackdrop({
            bgFile = [[Interface\PVPFrame\PVP-Currency-Horde]],
            edgeFile = nil,
            tileSize = 32, edgeSize = 16,
      })
   else
      Icon:SetBackdrop({
            bgFile = [[Interface\PVPFrame\PVP-Currency-Alliance]],
            edgeFile = nil,
            tileSize = 32, edgeSize = 16,
      })
   end
end
FactionIcon()
Icon:SetPoint("topleft", BGStatFrame, "topleft", 0, -2)
Icon.text = Icon:CreateFontString(nil, nil, "QuestFont_Shadow_Small")
Icon.text:SetPoint("left", 25, 0)
Icon.text:SetText("BG Stats")
Icon:Show()

------------------------------------------------------------------------------------------------------------------------

local CloseButton = CreateFrame("Button", "CloseButton", BGStatFrame)
CloseButton:SetWidth(16)
CloseButton:SetHeight(16)
CloseButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up")
CloseButton:SetHighlightTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Highlight")
CloseButton:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down")
CloseButton:SetPoint("topright", BGStatFrame, "topright", 0, -2)
CloseButton:Show()
CloseButton:SetScript("OnClick",  function() 
      BGStatFrame:Hide() 
      IsShown = false
end)

----------------------------------------
-- Small Frames
----------------------------------------
local HonorFrame = CreateFrame("frame", "HonorFrame", BGStatFrame)
HonorFrame.text = HonorFrame:CreateFontString(nil, nil, "GameFontNormal")
HonorFrame.text:SetPoint("left", 25, 0)
function UpdateHonorInfo()
   --local _, CurrInfo, _, _, _, _ = GetCurrencyInfo(392)
   HonorFrame.text:SetText(GetHonor())
end
UpdateHonorInfo()
HonorFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25)
HonorFrame:SetWidth(BGStatFrame:GetWidth())
HonorFrame:SetHeight(20)
HonorFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local HonorFrameIcon = CreateFrame("frame", "HonorFrameIcon", HonorFrame)
function HonorIcon()
   local EnglishFaction, localizedFaction = UnitFactionGroup("player")
   if EnglishFaction == "Horde" then
      HonorFrameIcon:SetBackdrop({
            bgFile = [[Interface\PvPFrame\PVPCurrency-Honor-Horde]],
            edgeFile = nill,
            tile = true,
            tileSize = HonorFrame:GetHeight() + 4, edgeSize = HonorFrame:GetHeight() + 4,
            insets = { left = 0, right = 0, top = 0, bottom = 0 }
      })
   else
      HonorFrameIcon:SetBackdrop({
            bgFile = [[Interface\PvPFrame\PVPCurrency-Honor-Alliance]],
            edgeFile = nill,
            tile = true,
            tileSize = HonorFrame:GetHeight() + 4, edgeSize = HonorFrame:GetHeight() + 4,
            insets = { left = 0, right = 0, top = 0, bottom = 0 }
      })
   end
end
HonorIcon()
HonorFrameIcon:SetWidth(HonorFrame:GetHeight())
HonorFrameIcon:SetHeight(HonorFrame:GetHeight())
HonorFrameIcon:SetPoint("left", HonorFrame, "left", 0, 0)
HonorFrameIcon:Show()

------------------------------------------------------------------------------------------------------------------------

local ConquestFrame = CreateFrame("frame", "ConquestFrame", BGStatFrame)
ConquestFrame.text = ConquestFrame:CreateFontString(nil, nil, "GameFontNormal")
ConquestFrame.text:SetPoint("left", 25, 0)
function UpdateConquestInfo()
   --local _, CurrInfo, _, _, _, _ = GetCurrencyInfo(390)
   ConquestFrame.text:SetText(GetConquest())
end
UpdateConquestInfo()
space = 0
if HonorFrame:IsShown() then
   space = HonorFrame:GetHeight()
end
ConquestFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25 - space)
ConquestFrame:SetWidth(BGStatFrame:GetWidth())
ConquestFrame:SetHeight(20)
ConquestFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local ConquestFrameIcon = CreateFrame("frame", "ConquestFrameIcon", ConquestFrame)
function ConquestIcon()
   local EnglishFaction, localizedFaction = UnitFactionGroup("player")
   if EnglishFaction == "Horde" then
      ConquestFrameIcon:SetBackdrop({
            bgFile = [[Interface\PvPFrame\PVPCurrency-Conquest-Horde]],
            edgeFile = nill,
            tile = true,
            tileSize = ConquestFrame:GetHeight() + 4, edgeSize = ConquestFrame:GetHeight() + 4,
            insets = { left = 0, right = 0, top = 0, bottom = 0 }
      })
   else
      ConquestFrameIcon:SetBackdrop({
            bgFile = [[Interface\PvPFrame\PVPCurrency-Conquest-Alliance]],
            edgeFile = nill,
            tile = true,
            tileSize = ConquestFrame:GetHeight() + 4, edgeSize = ConquestFrame:GetHeight() + 4,
            insets = { left = 0, right = 0, top = 0, bottom = 0 }
      })
   end
end
ConquestIcon()
ConquestFrameIcon:SetWidth(ConquestFrame:GetHeight())
ConquestFrameIcon:SetHeight(ConquestFrame:GetHeight())
ConquestFrameIcon:SetPoint("left", ConquestFrame, "left", 0, 0)
ConquestFrameIcon:Show()

------------------------------------------------------------------------------------------------------------------------

local KillsFrame = CreateFrame("frame", "KillsFrame", BGStatFrame)
KillsFrame.text = KillsFrame:CreateFontString(nil, nil, "GameFontNormal")
KillsFrame.text:SetPoint("left", 25, 0)
function UpdateKillsInfo()
   --local HKills, _, _ = GetPVPLifetimeStats()
   KillsFrame.text:SetText(GetHKills())
end
space = 0
if HonorFrame:IsShown() then
   space = space + HonorFrame:GetHeight()
end
if ConquestFrame:IsShown() then
   space = space + ConquestFrame:GetHeight()
end
KillsFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25 - space)
KillsFrame:SetWidth(BGStatFrame:GetWidth())
KillsFrame:SetHeight(20)
KillsFrame:Hide()
KillsFrame:SetScript("OnShow", UpdateKillsInfo)

------------------------------------------------------------------------------------------------------------------------

local KillsFrameIcon = CreateFrame("frame", "KillsFrameIcon", KillsFrame)
KillsFrameIcon:SetBackdrop({
      bgFile = [[Interface\TARGETINGFRAME\UI-TargetingFrame-Skull]],
      edgeFile = nill,
      tile = true,
      tileSize = KillsFrame:GetHeight()  , edgeSize = KillsFrame:GetHeight()  ,
      insets = { left = 4, right = -2, top = 3, bottom = 1 }
})
KillsFrameIcon:SetWidth(KillsFrame:GetHeight())
KillsFrameIcon:SetHeight(KillsFrame:GetHeight())
KillsFrameIcon:SetPoint("left", KillsFrame, "left", 0, 0)
KillsFrameIcon:Show()

------------------------------------------------------------------------------------------------------------------------

local AchFrame = CreateFrame("frame", "AchFrame", BGStatFrame)
AchFrame.text = AchFrame:CreateFontString(nil, nil, "GameFontNormal")
AchFrame.text:SetPoint("left", 25, 0)
AchFrame:SetWidth(BGStatFrame:GetWidth())
AchFrame:SetHeight(20)
AchFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local AchFrameIcon = CreateFrame("frame", "AchFrameIcon", AchFrame)
function UpdateAchInfo()
   local HKills = GetHKills()
   local AchRankPath = [[]]
   local KillsLeft = 0
   if HKills < 1 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_01]]
      KillsLeft = 1 - HKills
   elseif 1 < HKills and HKills < 100 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_02]]
      KillsLeft = 100 - HKills
   elseif 100 < HKills and HKills < 500 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_03]]
      KillsLeft = 500 - HKills
   elseif 500 < HKills and HKills < 1000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_04]]
      KillsLeft = 1000 - HKills
   elseif 1000 < HKills and HKills < 5000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_06]]
      KillsLeft = 5000 - HKills
   elseif 5000 < HKills and HKills < 10000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_09]]
      KillsLeft = 10000 - HKills
   elseif 10000 < HKills and HKills < 25000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_11]]
      KillsLeft = 25000 - HKills
   elseif 25000 < HKills and HKills < 50000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_14]]
      KillsLeft = 50000 - HKills
   elseif 50000 < HKills and HKills < 100000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_15]]
      KillsLeft = 100000 - HKills
   elseif 100000 < HKills and HKills < 250000 then
      AchRankPath = [[Interface\ICONS\Achievement_PVP_P_16]]
      KillsLeft = 250000 - HKills
   elseif 250000 < HKills then
      AchRankPath = [[Interface\ICONS\Achievement_BG_KillFlagCarriers_grabFlag_CapIt]]
      KillsLeft = "Max Rank"
   end
   AchFrameIcon:SetBackdrop({
         bgFile = AchRankPath,
         edgeFile = nill,
         tile = false,
         tileSize = AchFrame:GetHeight() + 4 , edgeSize = AchFrame:GetHeight()  ,
         insets = { left = 5, right = 4, top = 1 , bottom = 2 }
   })
   
   AchFrame.text:SetText(KillsLeft)
   
end
AchFrameIcon:SetWidth(AchFrame:GetHeight() + 5)
AchFrameIcon:SetHeight(AchFrame:GetHeight())
AchFrameIcon:SetPoint("left", AchFrame, "left", 0, 0)
AchFrameIcon:Show()
AchFrame:SetScript("OnShow", UpdateAchInfo)
AchFrame:Show()
AchFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

--[[
local HolidayFrame = CreateFrame("frame", "HolidayFrame", BGStatFrame)
HolidayFrame.text = HolidayFrame:CreateFontString(nil, nil, "GameFontNormal")
HolidayFrame.text:SetPoint("left", 25, 0)
HolidayFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, -25)
HolidayFrame:SetWidth(BGStatFrame:GetWidth())
HolidayFrame:SetHeight(20)
HolidayFrame:Hide()

local HolidayFrameIcon = CreateFrame("frame", "HolidayFrameIcon", HolidayFrame)
HolidayFrameIcon:SetWidth(HolidayFrame:GetHeight())
HolidayFrameIcon:SetHeight(HolidayFrame:GetHeight())
HolidayFrameIcon:SetPoint("left", HolidayFrame, "left", 0, 0)
HolidayFrameIcon:Show()
function UpdateHolidayInfo()
   OpenCalendar()
   
local TodayNr = date("%d") ;
----DEFAULT_CHAT:AddMessage(TodayNr)

local MonthNr = 0;
local IconPath = InterFace\ICONS\Spell_Shadow_Twilight;
local HolidayEvent = "No Holiday";
----DEFAULT_CHAT:AddMessage(TodayNr .. "  " .. MonthNr)
local CountedEvents = CalendarGetNumDayEvents(MonthNr, TodayNr);
----DEFAULT_CHAT:AddMessage(CountedEvents)
OpenCalendar()
CountedEvents = CalendarGetNumDayEvents(MonthNr, TodayNr);
----DEFAULT_CHAT:AddMessage(CountedEvents)
for i = 1, CountedEvents  do
----DEFAULT_CHAT:AddMessage("updating2")
   local name, description, texture = CalendarGetHolidayInfo(MonthNr, TodayNr, i);
   
   local StrFoundNr = string.find(name, "Call to ")
   if StrFoundNr ~= nil then 
      HolidayEvent = name
   end
end

------DEFAULT_CHAT:AddMessage("updating")
local ShortStr = string.replace(HolidayEvent, "Call to Arms: ", "")
------DEFAULT_CHAT:AddMessage(ShortStr)
if ShortStr == "Warsong Gulch" then
   ShortStr = "Warsong"
   IconPath = InterFace\ICONS\inv_misc_rune_07
elseif ShortStr == "Alterac Valley" then
   ShortStr = "Alterac"
   IconPath = InterFace\ICONS\inv_jewelry_necklace_21
elseif ShortStr == "Eye of the Storm" then
   ShortStr = "Eye o/t Storm"
   IconPath = InterFace\ICONS\spell_nature_eyeofthestorm
elseif ShortStr == "Strand of the Ancients" then
   ShortStr = "Strand"
   IconPath = InterFace\ICONS\achievement_bg_winsoa
elseif ShortStr == "Isle of Conquest" then
   ShortStr = "Conquest"
   IconPath = InterFace\ICONS\achievement_bg_winwsg
elseif ShortStr == "The Battle for Gilneas" then
   ShortStr = "Gilneas"
   IconPath = InterFace\ICONS\achievement_battleground_battleforgilneas
elseif ShortStr == "Twin Peaks" then
   ShortStr = "Twinn Peaks"
   IconPath = InterFace\ICONS\spell_nature_earthshock
elseif ShortStr == "Arathi Basin" then
   ShortStr = "Twinn Peaks"
   IconPath = InterFace\ICONS\inv_jewelry_amulet_07
end

HolidayFrame.text:SetText(ShortStr)

HolidayFrameIcon:SetBackdrop({
      bgFile =  IconPath,
      edgeFile = nill,
      tile = true,
      tileSize = HolidayFrame:GetHeight(), edgeSize = HolidayFrame:GetHeight(),
      insets = { left = 4, right = 0, top = 2 , bottom = 2 }
})

   
end
UpdateHolidayInfo()

]]--

------------------------------------------------------------------------------------------------------------------------

local BGScoreFrame = CreateFrame("frame", "BGScoreFrame", BGStatFrame)
BGScoreFrame.text = BGScoreFrame:CreateFontString(nil, nil, "GameFontNormal")
BGScoreFrame.text:SetPoint("left", 25, 0)
function UpdateBGScoreInfo()
   ------DEFAULT_CHAT:AddMessage("Updating nr 2")
   for i = 1, GetNumBattlefieldScores() do
      local name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone = GetBattlefieldScore(i)
      ------DEFAULT_CHAT:AddMessage(name .. "")
      if name == GetUnitName("player", false) then
         BGScoreFrame.text:SetText("" .. honorableKills .. "(" .. killingBlows .. ") / " .. deaths)
      end
   end
end
UpdateBGScoreInfo()
BGScoreFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, 0)
BGScoreFrame:SetWidth(BGStatFrame:GetWidth())
BGScoreFrame:SetHeight(20)
BGScoreFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local BGScoreFrameIcon = CreateFrame("frame", "BGScoreFrameIcon", BGScoreFrame)
function BGScoreIcon()
   local EnglishFaction, localizedFaction = UnitFactionGroup("player")
   if EnglishFaction == "Horde" then
      BGScoreFrameIcon:SetBackdrop({
            bgFile = [[Interface\ICONS\Achievement_PVP_H_H]],
            edgeFile = nill,
            tile = true,
            tileSize = BGScoreFrame:GetHeight(), edgeSize = BGScoreFrame:GetHeight(),
            insets = { left = 4, right = 0, top = 2, bottom = 2 }
      })
   else
      BGScoreFrameIcon:SetBackdrop({
            bgFile = [[Interface\ICONS\Achievement_PVP_A_A]],
            edgeFile = nill,
            tile = false,
            tileSize = BGScoreFrame:GetHeight(), edgeSize = BGScoreFrame:GetHeight(),
            insets = { left = 4, right = 0, top = 2, bottom = 4 }
      })
   end
end
BGScoreIcon()
BGScoreFrameIcon:SetWidth(BGScoreFrame:GetHeight())
BGScoreFrameIcon:SetHeight(BGScoreFrame:GetHeight())
BGScoreFrameIcon:SetPoint("left", BGScoreFrame, "left", 0, 0)
BGScoreFrameIcon:Show()


----------------------------------------
-- Functions
----------------------------------------


function FrameHeights()
   local spacing = -25
   ------DEFAULT_CHAT:AddMessage(table.getn(FrameTable) .. " started")
   for  id, frame in ipairs(FrameTable) do
      local TempFrame = frame
      TempFrame:SetPoint("topleft", BGStatFrame, "topleft", 0, spacing)
      spacing = spacing - TempFrame:GetHeight()
      TempFrame:Show()
      ------DEFAULT_CHAT:AddMessage(table.getn(FrameTable) .. " counted")
   end
   ------DEFAULT_CHAT:AddMessage(table.getn(FrameTable) .. " loaded")
end

------------------------------------------------------------------------------------------------------------------------

function ResizeBG()
   local BGSize = 30
   for  id, frame in ipairs(FrameTable) do
      BGSize = BGSize + frame:GetHeight()
   end
   
   --[[ if HonorFrame:IsShown() then
      BGSize = BGSize + HonorFrame:GetHeight()
   end
   if ConquestFrame:IsShown() then
      BGSize = BGSize + ConquestFrame:GetHeight()
   end
   if KillsFrame:IsShown() then
      BGSize = BGSize + KillsFrame:GetHeight()
   end
   if AchFrame:IsShown() then
      BGSize = BGSize + AchFrame:GetHeight()
   end]]--
   BGStatFrame:SetHeight(BGSize)
end

ResizeBG()

------------------------------------------------------------------------------------------------------------------------

function TableRemoveFrame(FrameName2)
   ------DEFAULT_CHAT:AddMessage("Removed called")
   for  id, frame in ipairs(FrameTable) do
      local TempFrameName = frame:GetName()
      ------DEFAULT_CHAT:AddMessage("table: " .. TempFrameName)
      if TempFrameName == FrameName2 then
         ------DEFAULT_CHAT:AddMessage("Removing")
         table.remove(FrameTable, id)
      end
   end
   
end

------------------------------------------------------------------------------------------------------------------------

function TableAddFrame(FrameName3)
   
   table.insert(FrameTable, table.getn(FrameTable) + 1, FrameName3)
   --DEFAULT_CHAT:AddMessage("added: " .. FrameName3:GetName() .. " at " .. table.getn(FrameTable))
   
end


----------------------------------------
-- Options Frame
----------------------------------------


local OptionsFrame = CreateFrame("frame", "OptionsFrame")
OptionsFrame:SetBackdrop({
      bgFile = [[Interface\DialogFrame\UI-DialogBox-Background-Dark]],
      edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]],
      tileSize = 16, edgeSize = 16,
      insets = { left = 3, right = 3, top = 5, bottom = 3 }
})
OptionsFrame:SetWidth(170)
OptionsFrame:SetHeight(150)
OptionsFrame:EnableMouse(true)
OptionsFrame:SetMovable(true)
OptionsFrame:SetPoint("Center", 0, 0)
OptionsFrame:RegisterForDrag("LeftButton")
OptionsFrame:SetScript("OnDragStart", OptionsFrame.StartMoving )
OptionsFrame:SetScript("OnDragStop", 
OptionsFrame.StopMovingOrSizing)
OptionsFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local CloseOptionButton = CreateFrame("Button", "CloseOptionButton", OptionsFrame)
CloseOptionButton:SetWidth(20)
CloseOptionButton:SetHeight(20)
CloseOptionButton:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up")
CloseOptionButton:SetHighlightTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Highlight")
CloseOptionButton:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down")
CloseOptionButton:SetPoint("topright", OptionsFrame, "topright", -1, -1)
CloseOptionButton:SetScript("OnClick",  function() OptionsFrame:Hide() end)

------------------------------------------------------------------------------------------------------------------------

local OptionTitle = CreateFrame("frame", "OptionTitle", OptionsFrame)
OptionTitle:SetWidth(80)
OptionTitle:SetHeight(20)
OptionTitle:SetPoint("top", OptionsFrame, "top", 0, -5)
OptionTitle.text = OptionTitle:CreateFontString(nil, nil, "QuestFont_Shadow_Small")
OptionTitle.text:SetPoint("center", 0, 0)
OptionTitle.text:SetText("BG Stats Options")

----------------------------------------
-- CheckButtons
----------------------------------------

local CBHonor = CreateFrame("checkbutton", "CBHonor", OptionsFrame)
CBHonor:SetWidth(20)
CBHonor:SetHeight(20)
CBHonor:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
CBHonor:SetHighlightTexture("Interface\\BUTTONS\UI-CheckBox-Highlight")
CBHonor:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
CBHonor:SetPoint("topleft", OptionsFrame, "topleft", 15, -30)
CBHonor.text = CBHonor:CreateFontString(nil, nil, "GameFontNormal")
CBHonor.text:SetPoint("left", 25, 0)
CBHonor.text:SetText("Show Honor")
CBHonor:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
CBHonor:SetScript("OnClick", function ()
      if  HonorFrame:IsShown() then
         HonorFrame:Hide()
         CBHonor:SetChecked(false)
         TableRemoveFrame("HonorFrame")
      else
         HonorFrame:Show()
         CBHonor:SetChecked(true)
         TableAddFrame(HonorFrame)
      end
      FrameHeights()
      ResizeBG()
end)

------------------------------------------------------------------------------------------------------------------------

local CBConquest = CreateFrame("checkbutton", "CBConquest", OptionsFrame)
CBConquest:SetWidth(20)
CBConquest:SetHeight(20)
CBConquest:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
CBConquest:SetHighlightTexture("Interface\\BUTTONS\UI-CheckBox-Highlight")
CBConquest:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
CBConquest:SetPoint("topleft", OptionsFrame, "topleft", 15, -50)
CBConquest.text = CBConquest:CreateFontString(nil, nil, "GameFontNormal")
CBConquest.text:SetPoint("left", 25, 0)
CBConquest.text:SetText("Show Conquest")
CBConquest:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
CBConquest:SetScript("OnClick", function ()
      if  ConquestFrame:IsShown() then
         ConquestFrame:Hide()
         CBConquest:SetChecked(false)
         TableRemoveFrame("ConquestFrame")
      else
         ConquestFrame:Show()
         CBConquest:SetChecked(true)
         TableAddFrame(ConquestFrame)
      end
      FrameHeights()
      ResizeBG()
end)

------------------------------------------------------------------------------------------------------------------------

local CBKills = CreateFrame("checkbutton", "CBKills", OptionsFrame)
CBKills:SetWidth(20)
CBKills:SetHeight(20)
CBKills:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
CBKills:SetHighlightTexture("Interface\\BUTTONS\UI-CheckBox-Highlight")
CBKills:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
CBKills:SetPoint("topleft", OptionsFrame, "topleft", 15, -70)
CBKills.text = CBKills:CreateFontString(nil, nil, "GameFontNormal")
CBKills.text:SetPoint("left", 25, 0)
CBKills.text:SetText("Show Kills")
CBKills:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
CBKills:SetScript("OnClick", function ()
      if  KillsFrame:IsShown() then
         KillsFrame:Hide()
         CBKills:SetChecked(false)
         TableRemoveFrame("KillsFrame")
      else
         KillsFrame:Show()
         CBKills:SetChecked(true)
         TableAddFrame(KillsFrame)
      end
      FrameHeights()
      ResizeBG()
end)

------------------------------------------------------------------------------------------------------------------------

local CBAch = CreateFrame("checkbutton", "CBAch", OptionsFrame)
CBAch:SetWidth(20)
CBAch:SetHeight(20)
CBAch:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
CBAch:SetHighlightTexture("Interface\\BUTTONS\UI-CheckBox-Highlight")
CBAch:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
CBAch:SetPoint("topleft", OptionsFrame, "topleft", 15, -90)
CBAch.text = CBAch:CreateFontString(nil, nil, "GameFontNormal")
CBAch.text:SetPoint("left", 25, 0)
CBAch.text:SetText("Show Achievement")
CBAch:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
CBAch:SetScript("OnClick", function ()
      if  AchFrame:IsShown() then
         AchFrame:Hide()
         CBAch:SetChecked(false)
         TableRemoveFrame("AchFrame")
      else
         AchFrame:Show()
         CBAch:SetChecked(true)
         TableAddFrame(AchFrame)
      end
      FrameHeights()
      ResizeBG()
end)

------------------------------------------------------------------------------------------------------------------------

--[[
local CBHoliday = CreateFrame("checkbutton", "CBHoliday", OptionsFrame)
CBHoliday:SetWidth(20)
CBHoliday:SetHeight(20)
CBHoliday:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")

CBHoliday:SetHighlightTexture("Interface\\BUTTONS\UI-CheckBox-Highlight")
CBHoliday:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
CBHoliday:SetPoint("topleft", OptionsFrame, "topleft", 15, -110)
CBHoliday.text = CBHoliday:CreateFontString(nil, nil, "GameFontNormal")
CBHoliday.text:SetPoint("left", 25, 0)
CBHoliday.text:SetText("Show Holiday")
CBHoliday:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
CBHoliday:SetScript("OnClick", function ()
      if  HolidayFrame:IsShown() then
         HolidayFrame:Hide()
         CBHoliday:SetChecked(false)
         TableRemoveFrame("HolidayFrame")
      else
         HolidayFrame:Show()
         CBHoliday:SetChecked(true)
         TableAddFrame(HolidayFrame)
      end
      FrameHeights()
      ResizeBG()
end)
]]--

------------------------------------------------------------------------------------------------------------------------

local CBBGScoreFrame = CreateFrame("checkbutton", "CBBGScoreFrame", OptionsFrame)
CBBGScoreFrame:SetWidth(20)
CBBGScoreFrame:SetHeight(20)
CBBGScoreFrame:SetNormalTexture("Interface\\BUTTONS\\UI-CheckBox-Up")
CBBGScoreFrame:SetHighlightTexture("Interface\\BUTTONS\UI-CheckBox-Highlight")
CBBGScoreFrame:SetPushedTexture("Interface\\BUTTONS\\UI-CheckBox-Down")
CBBGScoreFrame:SetPoint("topleft", OptionsFrame, "topleft", 15, -110)
CBBGScoreFrame.text = CBBGScoreFrame:CreateFontString(nil, nil, "GameFontNormal")
CBBGScoreFrame.text:SetPoint("left", 25, 0)
CBBGScoreFrame.text:SetText("Show BG Stats")
CBBGScoreFrame:SetCheckedTexture("Interface\\BUTTONS\\UI-CheckBox-Check")
CBBGScoreFrame:SetScript("OnClick", function ()
      if  BGScoreFrame:IsShown() then
         BGScoreFrame:Hide()
         CBBGScoreFrame:SetChecked(false)
         TableRemoveFrame("BGScoreFrame")
      else
         BGScoreFrame:Show()
         CBBGScoreFrame:SetChecked(true)
         TableAddFrame(BGScoreFrame)
      end
      FrameHeights()
      ResizeBG()
end)


----------------------------------------
-- Info Frame
----------------------------------------


local InfoFrame = CreateFrame("frame", "InfoFrame")
InfoFrame:SetBackdrop({
      bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
      edgeFile = nill,
      tileSize = 16, edgeSize = 16,
      insets = { left = 3, right = 3, top = 5, bottom = 3 }
})
InfoFrame:SetWidth(250)
InfoFrame:SetHeight(210)
InfoFrame:EnableMouse(true)
InfoFrame:SetMovable(true)
InfoFrame:SetPoint("Center", 0, 0)
InfoFrame:RegisterForDrag("LeftButton")
InfoFrame:SetScript("OnDragStart", InfoFrame.StartMoving )
InfoFrame:SetScript("OnDragStop", InfoFrame.StopMovingOrSizing)
InfoFrame.text = InfoFrame:CreateFontString(nil, nil, "QuestFont_Shadow_Small")
InfoFrame.text:SetPoint("top", 0, -10)
InfoFrame.text:SetText("BG Stats Information")
InfoFrame:Hide()

------------------------------------------------------------------------------------------------------------------------

local InfoText = CreateFrame("SimpleHTML", "InfoText", InfoFrame)
InfoText:SetWidth(InfoFrame:GetWidth()- 30)
InfoText:SetHeight(InfoFrame:GetHeight() - 30)
InfoText:SetPoint("topleft", InfoFrame, "Topleft", 15, -30)
InfoText:SetFont("Fonts\\FRIZQT__.TTF", 11)
InfoText:SetText('<html><body><p>|cffffcc00Author:|r LanceDH - Moonglade EU</p><p>|cffffcc00Version:|r 1.0</p><p>|cffffcc00Version Date:|r 24th of May 2011</p><br /><p>The frames will show up in the order you enable them.</p><p>|cffffcc00Honor:|r  Your honor points</p><p>|cffffcc00Conquest:|r Your conquest points</p><p>|cffffcc00Kills:|r Your lifetime honorable kills</p><p>|cffffcc00Achievement:|r Amound of kills needed until next achievement</p><p>|cffffcc00BG Stats:|r Your stats in the current battleground.</p><p align="right">|cffffcc00Honorable Kills|r(|cffffcc00Killing Blows|r)/|cffffcc00Deaths|r</p></body></html>')

------------------------------------------------------------------------------------------------------------------------

local CloseInfo = CreateFrame("Button", "CloseInfo", InfoFrame)
CloseInfo:SetWidth(16)
CloseInfo:SetHeight(16)
CloseInfo:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up")
CloseInfo:SetHighlightTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Highlight")
CloseInfo:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down")
CloseInfo:SetPoint("topright", InfoFrame, "topright", 0, -2)
CloseInfo:Show()
CloseInfo:SetScript("OnClick",  function() InfoFrame:Hide() end)

------------------------------------------------------------------------------------------------------------------------

local InfoButton = CreateFrame("Button", "InfoButton", OptionsFrame)
InfoButton:SetWidth(14)
InfoButton:SetHeight(14)
InfoButton:SetNormalTexture("Interface\\FriendsFrame\\InformationIcon")
InfoButton:SetHighlightTexture("Interface\\FriendsFrame\\InformationIcon-Highlight")
InfoButton:SetPoint("bottomright", OptionsFrame, "bottomright", -5, 5)
InfoButton:Show()
InfoButton:SetScript("OnClick",  function() InfoFrame:Show() end)
InfoButton:SetAlpha(0.5)


----------------------------------------
-- Updates
----------------------------------------

function KillInfos()
   UpdateKillsInfo()
   UpdateAchInfo()
end

------------------------------------------------------------------------------------------------------------------------

function CurrInfos()
   UpdateConquestInfo()
   UpdateHonorInfo()
   
end

----------------------------------------
-- Event Frames
----------------------------------------

local KillEventFrame = CreateFrame("FRAME", "KillEventFrame");
KillEventFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
KillEventFrame:SetScript("OnEvent", KillInfos);

------------------------------------------------------------------------------------------------------------------------

local ConquestEventFrame = CreateFrame("FRAME", "ConquestEventFrame");
ConquestEventFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
ConquestEventFrame:SetScript("OnEvent", CurrInfos);

------------------------------------------------------------------------------------------------------------------------

local ZoneEventFrame = CreateFrame("FRAME", "ZoneEventFrame");
ZoneEventFrame:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND");
ZoneEventFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
ZoneEventFrame:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");
function ZoneEventFrame:OnEvent(event)
   if event == "PLAYER_ENTERING_BATTLEGROUND" or event == "UPDATE_BATTLEFIELD_SCORE" then
      UpdateBGScoreInfo()
   elseif event == "PLAYER_ENTERING_WORLD" then
      BGScoreFrame.text:SetText("Not in a BG")
   end
end
ZoneEventFrame:SetScript("OnEvent", ZoneEventFrame.OnEvent);

------------------------------------------------------------------------------------------------------------------------

local CinematicEventFrame = CreateFrame("FRAME", "CinematicEventFrame");
CinematicEventFrame:RegisterEvent("CINEMATIC_START");
CinematicEventFrame:RegisterEvent("CINEMATIC_STOP");
function CinematicEventFrame:OnEvent(event)
   if event == "CINEMATIC_START" then
      BGStatFrame:Hide()
   elseif event == "CINEMATIC_STOP" then
      if IsShown ~= false then 
         BGStatFrame:Show()
      end
   end
end
CinematicEventFrame:SetScript("OnEvent", CinematicEventFrame.OnEvent);
------------------------------------------------------------------------------------------------------------------------

local LoadedFrame = CreateFrame("FRAME", "LoadedFrame");
LoadedFrame:RegisterEvent("ADDON_LOADED");
LoadedFrame:RegisterEvent("PLAYER_LOGOUT");
function LoadedFrame:OnEvent(event)
   if event == "ADDON_LOADED" then
      if firstRun ~= false then
         ----DEFAULT_CHAT:AddMessage("" .. initialTable)
         
         --DEFAULT_CHAT:AddMessage("prob empty")
         if Ini ~= 1 then
            --DEFAULT_CHAT:AddMessage("adding")
            TableAddFrame(HonorFrame)
            TableAddFrame(ConquestFrame)
            TableAddFrame(KillsFrame)
            TableAddFrame(AchFrame)
            --TableAddFrame(HolidayFrame)
            TableAddFrame(BGScoreFrame)
            CBHonor:SetChecked(true)
            CBConquest:SetChecked(true)
            CBKills:SetChecked(true)
            CBAch:SetChecked(true)
            CBBGScoreFrame:SetChecked(true)
         else
            local HonorIn = true
            local ConquestIn = true
            local KillsIn = true
            local AchIn = true
            local BGIn = true
            --DEFAULT_CHAT:AddMessage("" .. table.getn(ShownFramesTable))
            for  id, frame in ipairs(ShownFramesTable)  do
               local FrameName = frame
               --DEFAULT_CHAT:AddMessage("bleh")
               if FrameName == "HonorFrame" and HonorIn then
                  HonorIn = false
                  TableAddFrame(HonorFrame)
                  HonorFrame:Show()
                  CBHonor:SetChecked(true)
               elseif FrameName == "ConquestFrame" and ConquestIn then
                  ConquestIn = false
                  TableAddFrame(ConquestFrame)
                  ConquestFrame:Show()
                  CBConquest:SetChecked(true)
               elseif FrameName == "KillsFrame" and KillsIn then
                  KillsIn = false
                  TableAddFrame(KillsFrame)
                  KillsFrame:Show()
                  CBKills:SetChecked(true)
               elseif FrameName == "AchFrame" and AchIn then
                  AchIn = false
                  TableAddFrame(AchFrame)
                  AchFrame:Show()
                  CBAch:SetChecked(true)
                  --elseif FrameName == "HolidayFrame" then
                  --  TableAddFrame(HolidayFrame)
                  --  HolidayFrame:Show()
                  -- CBHoliday:SetChecked(true)
               elseif FrameName == "BGScoreFrame" and BGIn then
                  BGIn = false
                  TableAddFrame(BGScoreFrame)
                  BGScoreFrame:Show()
                  CBBGScoreFrame:SetChecked(true)
               end
            end
         end
         
         
         
         
         ResizeBG()
         FrameHeights()
         
         CurrInfos()
         firstRun = false
      end
      if IsShown == false then
         BGStatFrame:Hide()
      else
         BGStatFrame:Show()
      end
      KillInfos()
      
      -- UpdateHolidayInfo()
      
      ------------------------------------------------------------------------------------------------------------------------
      
   elseif event == "PLAYER_LOGOUT" then
      
      ShownFramesTable = {}
      for  id, frame in ipairs(FrameTable) do
         local TempFrame = frame
         local TempFrameName = TempFrame:GetName()
         table.insert(ShownFramesTable, table.getn(ShownFramesTable) + 1, TempFrameName)
      end
      Ini = 1
      
      if BGStatFrame:IsShown() then
         IsShown = true
      else
         IsShown = false
      end
      
   end
end
LoadedFrame:SetScript("OnEvent", LoadedFrame.OnEvent)

----------------------------------------
-- Slash Commands
----------------------------------------

SLASH_PVPSTATS1 = '/bgstats';
local function slashcmd(msg, editbox)
   if msg == 'show' then
      BGStatFrame:Show()
      IsShown = true
   elseif msg == 'options' then
      OptionsFrame:Show()
   elseif msg == 'info' then
      InfoFrame:Show()  
      
  --[[ elseif msg == 'print' then
      function printing()
         --DEFAULT_CHAT:AddMessage("printing")
         for  id, frame in ipairs(FrameTable) do
            local TempFrame = frame
            local TempFrameName = TempFrame:GetName()
            --DEFAULT_CHAT:AddMessage(TempFrameName .. " id: " .. id)
         end
      end
      printing()
      ]]--
      
   end
end
SlashCmdList["PVPSTATS"] = slashcmd

